// This file is generated by kconfig_compiler from ktorrent.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class Settings : public KConfigSkeleton
{
  public:

    static Settings *self();
    ~Settings();

    /**
      Set Maximum number of downloads (0 = no limit)
    */
    static
    void setMaxDownloads( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxDownloads: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxDownloads" ) ))
        self()->mMaxDownloads = v;
    }

    /**
      Get Maximum number of downloads (0 = no limit)
    */
    static
    int maxDownloads()
    {
      return self()->mMaxDownloads;
    }

    /**
      Set Maximum number of connections per download (0 = no limit)
    */
    static
    void setMaxConnections( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxConnections: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxConnections" ) ))
        self()->mMaxConnections = v;
    }

    /**
      Get Maximum number of connections per download (0 = no limit)
    */
    static
    int maxConnections()
    {
      return self()->mMaxConnections;
    }

    /**
      Set Maximum upload speed in KB/sec (0 = no limit)
    */
    static
    void setMaxUploadRate( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxUploadRate: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxUploadRate" ) ))
        self()->mMaxUploadRate = v;
    }

    /**
      Get Maximum upload speed in KB/sec (0 = no limit)
    */
    static
    int maxUploadRate()
    {
      return self()->mMaxUploadRate;
    }

    /**
      Set Port
    */
    static
    void setPort( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setPort: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > 65535)
      {
        kdDebug() << "setPort: value " << v << " is greater than the maximum value of 65535" << endl;
        v = 65535;
      }

      if (!self()->isImmutable( QString::fromLatin1( "port" ) ))
        self()->mPort = v;
    }

    /**
      Get Port
    */
    static
    int port()
    {
      return self()->mPort;
    }

    /**
      Set Show a system tray icon
    */
    static
    void setShowSystemTrayIcon( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "showSystemTrayIcon" ) ))
        self()->mShowSystemTrayIcon = v;
    }

    /**
      Get Show a system tray icon
    */
    static
    bool showSystemTrayIcon()
    {
      return self()->mShowSystemTrayIcon;
    }

    /**
      Set Keep seeding after download has finished
    */
    static
    void setKeepSeeding( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "keepSeeding" ) ))
        self()->mKeepSeeding = v;
    }

    /**
      Get Keep seeding after download has finished
    */
    static
    bool keepSeeding()
    {
      return self()->mKeepSeeding;
    }

    /**
      Set Torrent search engine
    */
    static
    void setSearchURL( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "searchURL" ) ))
        self()->mSearchURL = v;
    }

    /**
      Get Torrent search engine
    */
    static
    QString searchURL()
    {
      return self()->mSearchURL;
    }

    /**
      Set Directory to store temporary files
    */
    static
    void setTempDir( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "tempDir" ) ))
        self()->mTempDir = v;
    }

    /**
      Get Directory to store temporary files
    */
    static
    QString tempDir()
    {
      return self()->mTempDir;
    }

    /**
      Set Directory to store downloaded files
    */
    static
    void setSaveDir( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "saveDir" ) ))
        self()->mSaveDir = v;
    }

    /**
      Get Directory to store downloaded files
    */
    static
    QString saveDir()
    {
      return self()->mSaveDir;
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }
  protected:
    Settings();
    static Settings *mSelf;


    // downloads
    int mMaxDownloads;
    int mMaxConnections;
    int mMaxUploadRate;
    int mPort;
    bool mShowSystemTrayIcon;
    bool mKeepSeeding;
    QString mSearchURL;
    QString mTempDir;
    QString mSaveDir;

  private:
};

#endif

